---
title: AudioScheduledSourceNode
slug: Web/API/AudioScheduledSourceNode
tags:
  - API
  - Audio
  - AudioScheduledSourceNode
  - Interface
  - Media
  - Reference
  - Web Audio API
  - sound
---
<div>{{APIRef("Web Audio API")}}</div>

<p>The <code>AudioScheduledSourceNode</code> interface—part of the Web Audio API—is a parent interface for several types of audio source node interfaces which share the ability to be started and stopped, optionally at specified times. Specifically, this interface defines the {{domxref("AudioScheduledSourceNode.start", "start()")}} and {{domxref("AudioScheduledSourceNode.stop", "stop()")}} methods, as well as the {{domxref("AudioScheduledSourceNode.onended", "onended")}} event handler.</p>

<div class="note">
<p>You can't create an <code>AudioScheduledSourceNode</code> object directly. Instead, use the interface which extends it, such as {{domxref("AudioBufferSourceNode")}}, {{domxref("OscillatorNode")}}, and {{domxref("ConstantSourceNode")}}.</p>
</div>

<p>Unless stated otherwise, nodes based upon <code>AudioScheduledSourceNode</code> output silence when not playing (that is, before <code>start()</code> is called and after <code>stop()</code> is called). Silence is represented, as always, by a stream of samples with the value zero (0).</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent interface, {{domxref("AudioNode")}}.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent interface, {{domxref("AudioNode")}}, and adds the following methods:</em></p>

<dl>
 <dt>{{domxref("AudioScheduledSourceNode.start", "start()")}}</dt>
 <dd>Schedules the node to begin playing the constant sound at the specified time. If no time is specified, the node begins playing immediately.</dd>
 <dt>{{domxref("AudioScheduledSourceNode.stop", "stop()")}}</dt>
 <dd>Schedules the node to stop playing at the specified time. If no time is specified, the node stops playing at once.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface:</p>

<dl>
 <dt><code><a href="/en-US/docs/Web/API/AudioScheduledSourceNode/ended_event">ended</a></code></dt>
 <dd>Fired when the source node has stopped playing, either because it's reached a predetermined stop time, the full duration of the audio has been performed, or because the entire buffer has been played.<br>
 Also available using the <code><a href="/en-US/docs/Web/API/AudioScheduledSourceNode/onended">onended</a></code> event handler property.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#AudioScheduledSourceNode', 'AudioScheduledSourceNode')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioScheduledSourceNode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li>{{domxref("AudioNode")}}</li>
</ul>
